diff --git a/app/test-eventdev/evt_common.h b/app/test-eventdev/evt_common.h
index 2f301a7e79..196eca8bd0 100644
--- a/app/test-eventdev/evt_common.h
+++ b/app/test-eventdev/evt_common.h
@@ -6,6 +6,7 @@
 #define _EVT_COMMON_
 
 #include <rte_common.h>
+#include <rte_crypto.h>
 #include <rte_debug.h>
 #include <rte_event_crypto_adapter.h>
 #include <rte_eventdev.h>
@@ -80,6 +81,7 @@ struct evt_options {
 	uint64_t optm_timer_tick_nsec;
 	enum evt_prod_type prod_type;
 	enum rte_event_crypto_adapter_mode crypto_adptr_mode;
+	enum rte_crypto_op_type crypto_op_type;
 };
 
 static inline bool
diff --git a/app/test-eventdev/evt_options.c b/app/test-eventdev/evt_options.c
index d3c704d2b3..8326734b64 100644
--- a/app/test-eventdev/evt_options.c
+++ b/app/test-eventdev/evt_options.c
@@ -38,6 +38,7 @@ evt_options_default(struct evt_options *opt)
 	opt->eth_queues = 1;
 	opt->vector_size = 64;
 	opt->vector_tmo_nsec = 100E3;
+	opt->crypto_op_type = RTE_CRYPTO_OP_TYPE_SYMMETRIC;
 }
 
 typedef int (*option_parser_t)(struct evt_options *opt,
@@ -142,6 +143,18 @@ evt_parse_crypto_adptr_mode(struct evt_options *opt, const char *arg)
 	return ret;
 }
 
+static int
+evt_parse_crypto_op_type(struct evt_options *opt, const char *arg)
+{
+	uint8_t op_type;
+	int ret;
+
+	ret = parser_read_uint8(&op_type, arg);
+	opt->crypto_op_type = op_type ? RTE_CRYPTO_OP_TYPE_ASYMMETRIC :
+					RTE_CRYPTO_OP_TYPE_SYMMETRIC;
+	return ret;
+}
+
 static int
 evt_parse_test_name(struct evt_options *opt, const char *arg)
 {
@@ -368,6 +381,8 @@ usage(char *program)
 		"\t--expiry_nsec      : event timer expiry ns.\n"
 		"\t--crypto_adptr_mode : 0 for OP_NEW mode (default) and\n"
 		"\t                      1 for OP_FORWARD mode.\n"
+		"\t--crypto_op_type   : 0 for SYM ops (default) and\n"
+		"\t                     1 for ASYM ops.\n"
 		"\t--mbuf_sz          : packet mbuf size.\n"
 		"\t--max_pkt_sz       : max packet size.\n"
 		"\t--prod_enq_burst_sz : producer enqueue burst size.\n"
@@ -442,6 +457,7 @@ static struct option lgopts[] = {
 	{ EVT_PROD_TIMERDEV,       0, 0, 0 },
 	{ EVT_PROD_TIMERDEV_BURST, 0, 0, 0 },
 	{ EVT_CRYPTO_ADPTR_MODE,   1, 0, 0 },
+	{ EVT_CRYPTO_OP_TYPE,	   1, 0, 0 },
 	{ EVT_NB_TIMERS,           1, 0, 0 },
 	{ EVT_NB_TIMER_ADPTRS,     1, 0, 0 },
 	{ EVT_TIMER_TICK_NSEC,     1, 0, 0 },
@@ -484,6 +500,7 @@ evt_opts_parse_long(int opt_idx, struct evt_options *opt)
 		{ EVT_PROD_TIMERDEV, evt_parse_timer_prod_type},
 		{ EVT_PROD_TIMERDEV_BURST, evt_parse_timer_prod_type_burst},
 		{ EVT_CRYPTO_ADPTR_MODE, evt_parse_crypto_adptr_mode},
+		{ EVT_CRYPTO_OP_TYPE, evt_parse_crypto_op_type},
 		{ EVT_NB_TIMERS, evt_parse_nb_timers},
 		{ EVT_NB_TIMER_ADPTRS, evt_parse_nb_timer_adptrs},
 		{ EVT_TIMER_TICK_NSEC, evt_parse_timer_tick_nsec},
diff --git a/app/test-eventdev/evt_options.h b/app/test-eventdev/evt_options.h
index 2231c58801..f23fb8a511 100644
--- a/app/test-eventdev/evt_options.h
+++ b/app/test-eventdev/evt_options.h
@@ -38,6 +38,7 @@
 #define EVT_PROD_TIMERDEV        ("prod_type_timerdev")
 #define EVT_PROD_TIMERDEV_BURST  ("prod_type_timerdev_burst")
 #define EVT_CRYPTO_ADPTR_MODE	 ("crypto_adptr_mode")
+#define EVT_CRYPTO_OP_TYPE	 ("crypto_op_type")
 #define EVT_NB_TIMERS            ("nb_timers")
 #define EVT_NB_TIMER_ADPTRS      ("nb_timer_adptrs")
 #define EVT_TIMER_TICK_NSEC      ("timer_tick_nsec")
@@ -298,6 +299,9 @@ evt_dump_producer_type(struct evt_options *opt)
 			 "Event crypto adapter producers");
 		evt_dump("crypto adapter mode", "%s",
 			 opt->crypto_adptr_mode ? "OP_FORWARD" : "OP_NEW");
+		evt_dump("crypto op type", "%s",
+			 (opt->crypto_op_type == RTE_CRYPTO_OP_TYPE_SYMMETRIC) ?
+			 "SYMMETRIC" : "ASYMMETRIC");
 		evt_dump("nb_cryptodev", "%u", rte_cryptodev_count());
 		break;
 	}
diff --git a/app/test-eventdev/test_perf_atq.c b/app/test-eventdev/test_perf_atq.c
index 67ff681666..6a2aa86fd2 100644
--- a/app/test-eventdev/test_perf_atq.c
+++ b/app/test-eventdev/test_perf_atq.c
@@ -53,11 +53,13 @@ perf_atq_worker(void *arg, const int enable_fwd_latency)
 			struct rte_crypto_op *op = ev.event_ptr;
 
 			if (op->status == RTE_CRYPTO_OP_STATUS_SUCCESS) {
-				if (op->sym->m_dst == NULL)
-					ev.event_ptr = op->sym->m_src;
-				else
-					ev.event_ptr = op->sym->m_dst;
-				rte_crypto_op_free(op);
+				if (op->type == RTE_CRYPTO_OP_TYPE_SYMMETRIC) {
+					if (op->sym->m_dst == NULL)
+						ev.event_ptr = op->sym->m_src;
+					else
+						ev.event_ptr = op->sym->m_dst;
+					rte_crypto_op_free(op);
+				}
 			} else {
 				rte_crypto_op_free(op);
 				continue;
diff --git a/app/test-eventdev/test_perf_common.c b/app/test-eventdev/test_perf_common.c
index 0378607cda..f2da6fd74c 100644
--- a/app/test-eventdev/test_perf_common.c
+++ b/app/test-eventdev/test_perf_common.c
@@ -7,6 +7,89 @@
 #include "test_perf_common.h"
 
 #define NB_CRYPTODEV_DESCRIPTORS 128
+#define DATA_SIZE		512
+struct modex_test_data {
+	enum rte_crypto_asym_xform_type xform_type;
+	struct {
+		uint8_t data[DATA_SIZE];
+		uint16_t len;
+	} base;
+	struct {
+		uint8_t data[DATA_SIZE];
+		uint16_t len;
+	} exponent;
+	struct {
+		uint8_t data[DATA_SIZE];
+		uint16_t len;
+	} modulus;
+	struct {
+		uint8_t data[DATA_SIZE];
+		uint16_t len;
+	} reminder;
+	uint16_t result_len;
+};
+
+static struct
+modex_test_data modex_test_case = {
+	.xform_type = RTE_CRYPTO_ASYM_XFORM_MODEX,
+	.base = {
+		.data = {
+			0xF8, 0xBA, 0x1A, 0x55, 0xD0, 0x2F, 0x85,
+			0xAE, 0x96, 0x7B, 0xB6, 0x2F, 0xB6, 0xCD,
+			0xA8, 0xEB, 0x7E, 0x78, 0xA0, 0x50
+		},
+		.len = 20,
+	},
+	.exponent = {
+		.data = {
+			0x01, 0x00, 0x01
+		},
+		.len = 3,
+	},
+	.reminder = {
+		.data = {
+			0x2C, 0x60, 0x75, 0x45, 0x98, 0x9D, 0xE0, 0x72,
+			0xA0, 0x9D, 0x3A, 0x9E, 0x03, 0x38, 0x73, 0x3C,
+			0x31, 0x83, 0x04, 0xFE, 0x75, 0x43, 0xE6, 0x17,
+			0x5C, 0x01, 0x29, 0x51, 0x69, 0x33, 0x62, 0x2D,
+			0x78, 0xBE, 0xAE, 0xC4, 0xBC, 0xDE, 0x7E, 0x2C,
+			0x77, 0x84, 0xF2, 0xC5, 0x14, 0xB5, 0x2F, 0xF7,
+			0xC5, 0x94, 0xEF, 0x86, 0x75, 0x75, 0xB5, 0x11,
+			0xE5, 0x0E, 0x0A, 0x29, 0x76, 0xE2, 0xEA, 0x32,
+			0x0E, 0x43, 0x77, 0x7E, 0x2C, 0x27, 0xAC, 0x3B,
+			0x86, 0xA5, 0xDB, 0xC9, 0x48, 0x40, 0xE8, 0x99,
+			0x9A, 0x0A, 0x3D, 0xD6, 0x74, 0xFA, 0x2E, 0x2E,
+			0x5B, 0xAF, 0x8C, 0x99, 0x44, 0x2A, 0x67, 0x38,
+			0x27, 0x41, 0x59, 0x9D, 0xB8, 0x51, 0xC9, 0xF7,
+			0x43, 0x61, 0x31, 0x6E, 0xF1, 0x25, 0x38, 0x7F,
+			0xAE, 0xC6, 0xD0, 0xBB, 0x29, 0x76, 0x3F, 0x46,
+			0x2E, 0x1B, 0xE4, 0x67, 0x71, 0xE3, 0x87, 0x5A
+		},
+		.len = 128,
+	},
+	.modulus = {
+		.data = {
+			0xb3, 0xa1, 0xaf, 0xb7, 0x13, 0x08, 0x00, 0x0a,
+			0x35, 0xdc, 0x2b, 0x20, 0x8d, 0xa1, 0xb5, 0xce,
+			0x47, 0x8a, 0xc3, 0x80, 0xf4, 0x7d, 0x4a, 0xa2,
+			0x62, 0xfd, 0x61, 0x7f, 0xb5, 0xa8, 0xde, 0x0a,
+			0x17, 0x97, 0xa0, 0xbf, 0xdf, 0x56, 0x5a, 0x3d,
+			0x51, 0x56, 0x4f, 0x70, 0x70, 0x3f, 0x63, 0x6a,
+			0x44, 0x5b, 0xad, 0x84, 0x0d, 0x3f, 0x27, 0x6e,
+			0x3b, 0x34, 0x91, 0x60, 0x14, 0xb9, 0xaa, 0x72,
+			0xfd, 0xa3, 0x64, 0xd2, 0x03, 0xa7, 0x53, 0x87,
+			0x9e, 0x88, 0x0b, 0xc1, 0x14, 0x93, 0x1a, 0x62,
+			0xff, 0xb1, 0x5d, 0x74, 0xcd, 0x59, 0x63, 0x18,
+			0x11, 0x3d, 0x4f, 0xba, 0x75, 0xd4, 0x33, 0x4e,
+			0x23, 0x6b, 0x7b, 0x57, 0x44, 0xe1, 0xd3, 0x03,
+			0x13, 0xa6, 0xf0, 0x8b, 0x60, 0xb0, 0x9e, 0xee,
+			0x75, 0x08, 0x9d, 0x71, 0x63, 0x13, 0xcb, 0xa6,
+			0x81, 0x92, 0x14, 0x03, 0x22, 0x2d, 0xde, 0x55
+		},
+		.len = 128,
+	},
+	.result_len = 128,
+};
 
 int
 perf_test_result(struct evt_test *test, struct evt_options *opt)
@@ -277,12 +360,10 @@ perf_event_timer_producer_burst(void *arg)
 static inline void
 crypto_adapter_enq_op_new(struct prod_data *p)
 {
-	struct rte_cryptodev_sym_session **crypto_sess = p->ca.crypto_sess;
 	struct test_perf *t = p->t;
 	const uint32_t nb_flows = t->nb_flows;
 	const uint64_t nb_pkts = t->nb_pkts;
 	struct rte_mempool *pool = t->pool;
-	struct rte_crypto_sym_op *sym_op;
 	struct evt_options *opt = t->opt;
 	uint16_t qp_id = p->ca.cdev_qp_id;
 	uint8_t cdev_id = p->ca.cdev_id;
@@ -300,22 +381,39 @@ crypto_adapter_enq_op_new(struct prod_data *p)
 	len = opt->mbuf_sz ? opt->mbuf_sz : RTE_ETHER_MIN_LEN;
 
 	while (count < nb_pkts && t->done == false) {
-		m = rte_pktmbuf_alloc(pool);
-		if (m == NULL)
-			continue;
+		if (opt->crypto_op_type == RTE_CRYPTO_OP_TYPE_SYMMETRIC) {
+			struct rte_crypto_sym_op *sym_op;
 
-		rte_pktmbuf_append(m, len);
-		op = rte_crypto_op_alloc(t->ca_op_pool,
+			op = rte_crypto_op_alloc(t->ca_op_pool,
 					 RTE_CRYPTO_OP_TYPE_SYMMETRIC);
-		sym_op = op->sym;
-		sym_op->m_src = m;
-		sym_op->cipher.data.offset = 0;
-		sym_op->cipher.data.length = len;
-		rte_crypto_op_attach_sym_session(
-			op, crypto_sess[flow_counter++ % nb_flows]);
+			m = rte_pktmbuf_alloc(pool);
+			if (m == NULL)
+				continue;
 
+			rte_pktmbuf_append(m, len);
+			sym_op = op->sym;
+			sym_op->m_src = m;
+			sym_op->cipher.data.offset = 0;
+			sym_op->cipher.data.length = len;
+			rte_crypto_op_attach_sym_session(
+				op, p->ca.crypto_sess[flow_counter++ % nb_flows]);
+		} else {
+			struct rte_crypto_asym_op *asym_op;
+			uint8_t *result = rte_zmalloc(NULL,
+					modex_test_case.result_len, 0);
+
+			op = rte_crypto_op_alloc(t->ca_op_pool,
+					 RTE_CRYPTO_OP_TYPE_ASYMMETRIC);
+			asym_op = op->asym;
+			asym_op->modex.base.data = modex_test_case.base.data;
+			asym_op->modex.base.length = modex_test_case.base.len;
+			asym_op->modex.result.data = result;
+			asym_op->modex.result.length = modex_test_case.result_len;
+			rte_crypto_op_attach_asym_session(
+				op, p->ca.crypto_sess[flow_counter++ % nb_flows]);
+		}
 		while (rte_cryptodev_enqueue_burst(cdev_id, qp_id, &op, 1) != 1 &&
-		       t->done == false)
+				t->done == false)
 			rte_pause();
 
 		count++;
@@ -325,7 +423,6 @@ crypto_adapter_enq_op_new(struct prod_data *p)
 static inline void
 crypto_adapter_enq_op_fwd(struct prod_data *p)
 {
-	struct rte_cryptodev_sym_session **crypto_sess = p->ca.crypto_sess;
 	const uint8_t dev_id = p->dev_id;
 	const uint8_t port = p->port_id;
 	struct test_perf *t = p->t;
@@ -333,7 +430,6 @@ crypto_adapter_enq_op_fwd(struct prod_data *p)
 	const uint64_t nb_pkts = t->nb_pkts;
 	struct rte_mempool *pool = t->pool;
 	struct evt_options *opt = t->opt;
-	struct rte_crypto_sym_op *sym_op;
 	uint32_t flow_counter = 0;
 	struct rte_crypto_op *op;
 	struct rte_event ev;
@@ -354,19 +450,37 @@ crypto_adapter_enq_op_fwd(struct prod_data *p)
 	len = opt->mbuf_sz ? opt->mbuf_sz : RTE_ETHER_MIN_LEN;
 
 	while (count < nb_pkts && t->done == false) {
-		m = rte_pktmbuf_alloc(pool);
-		if (m == NULL)
-			continue;
+		if (opt->crypto_op_type == RTE_CRYPTO_OP_TYPE_SYMMETRIC) {
+			struct rte_crypto_sym_op *sym_op;
 
-		rte_pktmbuf_append(m, len);
-		op = rte_crypto_op_alloc(t->ca_op_pool,
+			op = rte_crypto_op_alloc(t->ca_op_pool,
 					 RTE_CRYPTO_OP_TYPE_SYMMETRIC);
-		sym_op = op->sym;
-		sym_op->m_src = m;
-		sym_op->cipher.data.offset = 0;
-		sym_op->cipher.data.length = len;
-		rte_crypto_op_attach_sym_session(
-			op, crypto_sess[flow_counter++ % nb_flows]);
+			m = rte_pktmbuf_alloc(pool);
+			if (m == NULL)
+				continue;
+
+			rte_pktmbuf_append(m, len);
+			sym_op = op->sym;
+			sym_op->m_src = m;
+			sym_op->cipher.data.offset = 0;
+			sym_op->cipher.data.length = len;
+			rte_crypto_op_attach_sym_session(
+				op, p->ca.crypto_sess[flow_counter++ % nb_flows]);
+		} else {
+			struct rte_crypto_asym_op *asym_op;
+			uint8_t *result = rte_zmalloc(NULL,
+					modex_test_case.result_len, 0);
+
+			op = rte_crypto_op_alloc(t->ca_op_pool,
+					 RTE_CRYPTO_OP_TYPE_ASYMMETRIC);
+			asym_op = op->asym;
+			asym_op->modex.base.data = modex_test_case.base.data;
+			asym_op->modex.base.length = modex_test_case.base.len;
+			asym_op->modex.result.data = result;
+			asym_op->modex.result.length = modex_test_case.result_len;
+			rte_crypto_op_attach_asym_session(
+				op, p->ca.crypto_sess[flow_counter++ % nb_flows]);
+		}
 		ev.event_ptr = op;
 
 		while (rte_event_crypto_adapter_enqueue(dev_id, port, &ev, 1) != 1 &&
@@ -729,6 +843,37 @@ cryptodev_sym_sess_create(struct prod_data *p, struct test_perf *t)
 	return sess;
 }
 
+static void *
+cryptodev_asym_sess_create(struct prod_data *p, struct test_perf *t)
+{
+	const struct rte_cryptodev_asymmetric_xform_capability *capability;
+	struct rte_cryptodev_asym_capability_idx cap_idx;
+	struct rte_crypto_asym_xform xform;
+	void *sess;
+
+	xform.next = NULL;
+	xform.xform_type = RTE_CRYPTO_ASYM_XFORM_MODEX;
+	cap_idx.type = xform.xform_type;
+	capability = rte_cryptodev_asym_capability_get(p->ca.cdev_id, &cap_idx);
+	if (capability == NULL) {
+		evt_err("Device doesn't support MODEX. Test Skipped\n");
+		return NULL;
+	}
+
+	xform.modex.modulus.data = modex_test_case.modulus.data;
+	xform.modex.modulus.length = modex_test_case.modulus.len;
+	xform.modex.exponent.data = modex_test_case.exponent.data;
+	xform.modex.exponent.length = modex_test_case.exponent.len;
+
+	if (rte_cryptodev_asym_session_create(p->ca.cdev_id, &xform,
+			t->ca_asym_sess_pool, &sess)) {
+		evt_err("Failed to create asym session");
+		return NULL;
+	}
+
+	return sess;
+}
+
 int
 perf_event_dev_port_setup(struct evt_test *test, struct evt_options *opt,
 				uint8_t stride, uint8_t nb_queues,
@@ -804,7 +949,6 @@ perf_event_dev_port_setup(struct evt_test *test, struct evt_options *opt,
 
 		prod = 0;
 		for (; port < perf_nb_event_ports(opt); port++) {
-			struct rte_cryptodev_sym_session *crypto_sess;
 			union rte_event_crypto_metadata m_data;
 			struct prod_data *p = &t->prod[port];
 			uint32_t flow_id;
@@ -820,7 +964,7 @@ perf_event_dev_port_setup(struct evt_test *test, struct evt_options *opt,
 			p->ca.cdev_id = cdev_id;
 			p->ca.cdev_qp_id = qp_id;
 			p->ca.crypto_sess = rte_zmalloc_socket(
-				NULL, sizeof(crypto_sess) * t->nb_flows,
+				NULL, sizeof(void *) * t->nb_flows,
 				RTE_CACHE_LINE_SIZE, opt->socket_id);
 			p->t = t;
 
@@ -830,18 +974,36 @@ perf_event_dev_port_setup(struct evt_test *test, struct evt_options *opt,
 			m_data.response_info.queue_id = p->queue_id;
 
 			for (flow_id = 0; flow_id < t->nb_flows; flow_id++) {
-				crypto_sess = cryptodev_sym_sess_create(p, t);
-				if (crypto_sess == NULL)
-					return -ENOMEM;
-
 				m_data.response_info.flow_id = flow_id;
-				rte_cryptodev_session_event_mdata_set(cdev_id,
-						crypto_sess,
+				if (opt->crypto_op_type ==
+						RTE_CRYPTO_OP_TYPE_SYMMETRIC) {
+					struct rte_cryptodev_sym_session *sess;
+
+					sess = cryptodev_sym_sess_create(p, t);
+					if (sess == NULL)
+						return -ENOMEM;
+
+					rte_cryptodev_session_event_mdata_set(
+						cdev_id,
+						sess,
 						RTE_CRYPTO_OP_TYPE_SYMMETRIC,
 						RTE_CRYPTO_OP_WITH_SESSION,
 						&m_data, sizeof(m_data));
+					p->ca.crypto_sess[flow_id] = sess;
+				} else {
+					void *sess;
 
-				p->ca.crypto_sess[flow_id] = crypto_sess;
+					sess = cryptodev_asym_sess_create(p, t);
+					if (sess == NULL)
+						return -ENOMEM;
+					rte_cryptodev_session_event_mdata_set(
+						cdev_id,
+						sess,
+						RTE_CRYPTO_OP_TYPE_ASYMMETRIC,
+						RTE_CRYPTO_OP_WITH_SESSION,
+						&m_data, sizeof(m_data));
+					p->ca.crypto_sess[flow_id] = sess;
+				}
 			}
 
 			conf.event_port_cfg |=
@@ -1123,14 +1285,24 @@ perf_cryptodev_setup(struct evt_test *test, struct evt_options *opt)
 	}
 
 	t->ca_op_pool = rte_crypto_op_pool_create(
-		"crypto_op_pool", RTE_CRYPTO_OP_TYPE_SYMMETRIC, opt->pool_sz,
-		128, 0, rte_socket_id());
+		"crypto_op_pool", opt->crypto_op_type, opt->pool_sz,
+		128, sizeof(union rte_event_crypto_metadata),
+		rte_socket_id());
 	if (t->ca_op_pool == NULL) {
 		evt_err("Failed to create crypto op pool");
 		return -ENOMEM;
 	}
 
 	nb_sessions = evt_nr_active_lcores(opt->plcores) * t->nb_flows;
+	t->ca_asym_sess_pool = rte_cryptodev_asym_session_pool_create(
+		"ca_asym_sess_pool", nb_sessions, 0,
+		sizeof(union rte_event_crypto_metadata), SOCKET_ID_ANY);
+	if (t->ca_asym_sess_pool == NULL) {
+		evt_err("Failed to create sym session pool");
+		ret = -ENOMEM;
+		goto err;
+	}
+
 	t->ca_sess_pool = rte_cryptodev_sym_session_pool_create(
 		"ca_sess_pool", nb_sessions, 0, 0,
 		sizeof(union rte_event_crypto_metadata), SOCKET_ID_ANY);
@@ -1217,6 +1389,7 @@ perf_cryptodev_setup(struct evt_test *test, struct evt_options *opt)
 	rte_mempool_free(t->ca_op_pool);
 	rte_mempool_free(t->ca_sess_pool);
 	rte_mempool_free(t->ca_sess_priv_pool);
+	rte_mempool_free(t->ca_asym_sess_pool);
 
 	return ret;
 }
@@ -1258,6 +1431,7 @@ perf_cryptodev_destroy(struct evt_test *test, struct evt_options *opt)
 	rte_mempool_free(t->ca_op_pool);
 	rte_mempool_free(t->ca_sess_pool);
 	rte_mempool_free(t->ca_sess_priv_pool);
+	rte_mempool_free(t->ca_asym_sess_pool);
 }
 
 int
diff --git a/app/test-eventdev/test_perf_common.h b/app/test-eventdev/test_perf_common.h
index ea0907d61a..5651832cc9 100644
--- a/app/test-eventdev/test_perf_common.h
+++ b/app/test-eventdev/test_perf_common.h
@@ -40,7 +40,7 @@ struct worker_data {
 struct crypto_adptr_data {
 	uint8_t cdev_id;
 	uint16_t cdev_qp_id;
-	struct rte_cryptodev_sym_session **crypto_sess;
+	void **crypto_sess;
 };
 struct prod_data {
 	uint8_t dev_id;
@@ -70,6 +70,7 @@ struct test_perf {
 	struct rte_mempool *ca_op_pool;
 	struct rte_mempool *ca_sess_pool;
 	struct rte_mempool *ca_sess_priv_pool;
+	struct rte_mempool *ca_asym_sess_pool;
 } __rte_cache_aligned;
 
 struct perf_elt {
@@ -111,8 +112,6 @@ perf_process_last_stage(struct rte_mempool *const pool,
 		struct rte_event *const ev, struct worker_data *const w,
 		void *bufs[], int const buf_sz, uint8_t count)
 {
-	bufs[count++] = ev->event_ptr;
-
 	/* release fence here ensures event_prt is
 	 * stored before updating the number of
 	 * processed packets for worker lcores
@@ -120,9 +119,19 @@ perf_process_last_stage(struct rte_mempool *const pool,
 	rte_atomic_thread_fence(__ATOMIC_RELEASE);
 	w->processed_pkts++;
 
-	if (unlikely(count == buf_sz)) {
-		count = 0;
-		rte_mempool_put_bulk(pool, bufs, buf_sz);
+	if (ev->event_type == RTE_EVENT_TYPE_CRYPTODEV &&
+			((struct rte_crypto_op *)ev->event_ptr)->type ==
+				RTE_CRYPTO_OP_TYPE_ASYMMETRIC) {
+		struct rte_crypto_op *op = ev->event_ptr;
+
+		rte_free(op->asym->modex.result.data);
+		rte_crypto_op_free(op);
+	} else {
+		bufs[count++] = ev->event_ptr;
+		if (unlikely(count == buf_sz)) {
+			count = 0;
+			rte_mempool_put_bulk(pool, bufs, buf_sz);
+		}
 	}
 	return count;
 }
@@ -135,8 +144,6 @@ perf_process_last_stage_latency(struct rte_mempool *const pool,
 	uint64_t latency;
 	struct perf_elt *const m = ev->event_ptr;
 
-	bufs[count++] = ev->event_ptr;
-
 	/* release fence here ensures event_prt is
 	 * stored before updating the number of
 	 * processed packets for worker lcores
@@ -144,15 +151,23 @@ perf_process_last_stage_latency(struct rte_mempool *const pool,
 	rte_atomic_thread_fence(__ATOMIC_RELEASE);
 	w->processed_pkts++;
 
-	if (unlikely(count == buf_sz)) {
-		count = 0;
-		latency = rte_get_timer_cycles() - m->timestamp;
-		rte_mempool_put_bulk(pool, bufs, buf_sz);
+	if (ev->event_type == RTE_EVENT_TYPE_CRYPTODEV &&
+			((struct rte_crypto_op *)m)->type ==
+				RTE_CRYPTO_OP_TYPE_ASYMMETRIC) {
+		rte_free(((struct rte_crypto_op *)m)->asym->modex.result.data);
+		rte_crypto_op_free((struct rte_crypto_op *)m);
 	} else {
-		latency = rte_get_timer_cycles() - m->timestamp;
+		bufs[count++] = ev->event_ptr;
+		if (unlikely(count == buf_sz)) {
+			count = 0;
+			latency = rte_get_timer_cycles() - m->timestamp;
+			rte_mempool_put_bulk(pool, bufs, buf_sz);
+		} else {
+			latency = rte_get_timer_cycles() - m->timestamp;
+		}
+
+		w->latency += latency;
 	}
-
-	w->latency += latency;
 	return count;
 }
 
diff --git a/app/test-eventdev/test_perf_queue.c b/app/test-eventdev/test_perf_queue.c
index dcf6d82947..631a39f727 100644
--- a/app/test-eventdev/test_perf_queue.c
+++ b/app/test-eventdev/test_perf_queue.c
@@ -55,11 +55,13 @@ perf_queue_worker(void *arg, const int enable_fwd_latency)
 			struct rte_crypto_op *op = ev.event_ptr;
 
 			if (op->status == RTE_CRYPTO_OP_STATUS_SUCCESS) {
-				if (op->sym->m_dst == NULL)
-					ev.event_ptr = op->sym->m_src;
-				else
-					ev.event_ptr = op->sym->m_dst;
-				rte_crypto_op_free(op);
+				if (op->type == RTE_CRYPTO_OP_TYPE_SYMMETRIC) {
+					if (op->sym->m_dst == NULL)
+						ev.event_ptr = op->sym->m_src;
+					else
+						ev.event_ptr = op->sym->m_dst;
+					rte_crypto_op_free(op);
+				}
 			} else {
 				rte_crypto_op_free(op);
 				continue;
diff --git a/doc/guides/tools/testeventdev.rst b/doc/guides/tools/testeventdev.rst
index f7d813226d..a8e02d57a4 100644
--- a/doc/guides/tools/testeventdev.rst
+++ b/doc/guides/tools/testeventdev.rst
@@ -157,6 +157,11 @@ The following are the application command-line options:
         Set crypto adapter mode. Use 0 for OP_NEW (default) and 1 for
         OP_FORWARD mode.
 
+* ``--crypto_op_type``
+
+        Set crypto operation type. Use 0 for symmetric crypto ops (default)
+        and 1 for asymmetric crypto ops.
+
 * ``--mbuf_sz``
 
        Set packet mbuf size. Can be used to configure Jumbo Frames. Only